<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">print.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="print_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (c) 2021 Martin B. Krauss.</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Licensed under the MIT LICENSE.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// See the file &#39;LICENSE&#39; that should be distributed with this software or can</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// be found at &#39;https://gitlab.com/martin.b.krauss/cpp20-print&#39; for details.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef CPP20PRINT_PRINT_H</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define CPP20PRINT_PRINT_H</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__atom_8h.html">print_atom.h</a>&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__concepts_8h.html">print_concepts.h</a>&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__list_8h.html">print_list.h</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__options_8h.html">print_options.h</a>&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span>cpp20print::printing::detail {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">   23</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        std::ostream&amp; out,</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options,</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keyword">const</span> T&amp; t</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        ) </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;{ </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <a class="code" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">print_atom</a>(out, options, t);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;}</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ablePair T&gt;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> print_element(</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        std::ostream&amp; out,</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options,</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">const</span> T&amp; t</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        ) </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{ </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    print_pair(out, t, options);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;}</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">template</span>&lt;Pr<span class="keywordtype">int</span>ableListNoString T&gt;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> print_element(</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        std::ostream&amp; out,</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">const</span> PrintOptions&amp; options,</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keyword">const</span> T&amp; t</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        ) </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{ </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    print_list(out, t, options);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">   57</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">print_recursive</a>(</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options,</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> T&amp; t</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        ) </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;{ </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, options, t);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;}</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="print_8h.html#aa6b8a6af7bd70b1b05875ba379ede13c">   69</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">print_recursive</a>(</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options,</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keyword">const</span> T&amp; t,</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        ) </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;{ </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <a class="code" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">print_recursive</a>(out, options, t);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;}</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class </span>T, <span class="keyword">class </span>...Args&gt;</div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="print_8h.html#a36591a53d09fc0c1ed0b14ce88e3df1a">   85</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">print_recursive</a>(</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options,</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keyword">const</span> T&amp; t, </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">const</span> Args&amp; ...args</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        ) </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;{ </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, options, t);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    out &lt;&lt; options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#ad6abfeabd9d43b6bc40c801ee9f8c447">seperator</a>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <a class="code" href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">print_recursive</a>(out, options, args...);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;}</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="print_8h.html#ad5337a574ea6c177f4ffb967393a3eb8">   99</a></span>&#160;<span class="keyword">inline</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> <a class="code" href="print_8h.html#ad5337a574ea6c177f4ffb967393a3eb8">get_options</a>(<span class="keyword">const</span> T&amp;) {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> {};</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;}</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="print_8h.html#aa03606f937c8c5755f00f9516cf21a60">  104</a></span>&#160;<span class="keyword">inline</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> <a class="code" href="print_8h.html#ad5337a574ea6c177f4ffb967393a3eb8">get_options</a>(<span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options) {</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordflow">return</span> options;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;}</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;}</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">namespace </span>cpp20print::printing {</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class </span>...Args&gt;</div>
<div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">  117</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="keyword">const</span> Args&amp; ...args) {</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keyword">using</span> <a class="code" href="structcpp20print_1_1terminal_1_1TerminalColor.html">terminal::TerminalColor</a>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="comment">// If last argument is of class print options, set the options,</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="comment">// else leave default options. </span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="comment">// (Uses overaloaded function to check for options.)</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="comment">// Folds arguments and gets last.</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> options = (detail::get_options(args), ...); </div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    std::ostream&amp; oStream = options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#adfa26c950f1582c78c5959e92105b3b0">file</a>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; </div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="comment">// Make sure color setter is destroyed on exception, to reset stdout</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">try</span> {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="comment">// restores colors and stream flags on destruction </span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="comment">// (also when exception is thrown).</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="comment">// [must be named to stay in scope (!!!)]</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <a class="code" href="classcpp20print_1_1terminal_1_1StreamModifier.html">terminal::StreamModifier</a> streamModifier {oStream};</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        streamModifier.<a class="code" href="classcpp20print_1_1terminal_1_1StreamModifier.html#a4fda381c4f568351b550f67d3443592c">set_color</a>(options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#aa5f4d1eda21c196bd8401ff73f105073">color</a>, options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#ac348b84fbc0a26e6fcf42ea1b47639ca">weight</a>);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        detail::print_recursive(oStream, options, args...);</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        oStream &lt;&lt; options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a7cdc73646f3e8e6c275b892bc7e615fb">end</a>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    } <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="comment">// rethrows after stream flags have been reset.</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        std::rethrow_exception(std::current_exception());</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    }</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160; </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">if</span> (options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#aac74feccd61a36e30d44315f6a776a72">flush</a>)</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        oStream &lt;&lt; std::flush;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;}</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;}</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160; </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructcpp20print_1_1terminal_1_1TerminalColor_html"><div class="ttname"><a href="structcpp20print_1_1terminal_1_1TerminalColor.html">cpp20print::terminal::TerminalColor</a></div><div class="ttdoc">Defines constants for terminal escape sequences, which can be used to format color and weight of term...</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:47</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_aac74feccd61a36e30d44315f6a776a72"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#aac74feccd61a36e30d44315f6a776a72">cpp20print::printing::PrintOptions::flush</a></div><div class="ttdeci">bool flush</div><div class="ttdoc">If true appends std::flush to the stream (default=false)</div><div class="ttdef"><b>Definition:</b> print_options.h:56</div></div>
<div class="ttc" id="aclasscpp20print_1_1terminal_1_1StreamModifier_html_a4fda381c4f568351b550f67d3443592c"><div class="ttname"><a href="classcpp20print_1_1terminal_1_1StreamModifier.html#a4fda381c4f568351b550f67d3443592c">cpp20print::terminal::StreamModifier::set_color</a></div><div class="ttdeci">void set_color(const Color color, const Weight weight=Weight::Default)</div><div class="ttdoc">Set the output color and font weight for the associated stream.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:96</div></div>
<div class="ttc" id="aprint__atom_8h_html_ad47012d4b2f909cec110fa350eae7192"><div class="ttname"><a href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">cpp20print::printing::detail::print_atom</a></div><div class="ttdeci">void print_atom(std::ostream &amp;out, const PrintOptions &amp;, const T &amp;)</div><div class="ttdoc">Prints single object. Fallback for all other objects.</div><div class="ttdef"><b>Definition:</b> print_atom.h:22</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html">cpp20print::printing::PrintOptions</a></div><div class="ttdoc">Sets the options of the print() function.</div><div class="ttdef"><b>Definition:</b> print_options.h:42</div></div>
<div class="ttc" id="aprint__atom_8h_html"><div class="ttname"><a href="print__atom_8h.html">print_atom.h</a></div></div>
<div class="ttc" id="aprint__concepts_8h_html"><div class="ttname"><a href="print__concepts_8h.html">print_concepts.h</a></div></div>
<div class="ttc" id="aprint_8h_html_afe9466890a34c5498386a55281bf30a7"><div class="ttname"><a href="print_8h.html#afe9466890a34c5498386a55281bf30a7">cpp20print::printing::detail::print_element</a></div><div class="ttdeci">void print_element(std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</div><div class="ttdoc">Prints a single object. Default for objects that are not lists (&quot;atoms&quot;).</div><div class="ttdef"><b>Definition:</b> print.h:23</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_a7cdc73646f3e8e6c275b892bc7e615fb"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#a7cdc73646f3e8e6c275b892bc7e615fb">cpp20print::printing::PrintOptions::end</a></div><div class="ttdeci">std::string end</div><div class="ttdoc">Defines the terminating character in the output of print i (default=&quot;\n&quot;)</div><div class="ttdef"><b>Definition:</b> print_options.h:49</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_aa5f4d1eda21c196bd8401ff73f105073"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#aa5f4d1eda21c196bd8401ff73f105073">cpp20print::printing::PrintOptions::color</a></div><div class="ttdeci">Color color</div><div class="ttdoc">Defines the color of the output.</div><div class="ttdef"><b>Definition:</b> print_options.h:62</div></div>
<div class="ttc" id="aclasscpp20print_1_1terminal_1_1StreamModifier_html"><div class="ttname"><a href="classcpp20print_1_1terminal_1_1StreamModifier.html">cpp20print::terminal::StreamModifier</a></div><div class="ttdoc">Helper class that keeps track of stream flags.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:82</div></div>
<div class="ttc" id="aprint_8h_html_a84aa02fb20f80f38d0b6b7418094c9a3"><div class="ttname"><a href="print_8h.html#a84aa02fb20f80f38d0b6b7418094c9a3">cpp20print::printing::detail::print_recursive</a></div><div class="ttdeci">void print_recursive(std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</div><div class="ttdoc">Prints last element if only one left after recursion.</div><div class="ttdef"><b>Definition:</b> print.h:57</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_ac348b84fbc0a26e6fcf42ea1b47639ca"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#ac348b84fbc0a26e6fcf42ea1b47639ca">cpp20print::printing::PrintOptions::weight</a></div><div class="ttdeci">Weight weight</div><div class="ttdoc">Defines the font weight of the output.</div><div class="ttdef"><b>Definition:</b> print_options.h:65</div></div>
<div class="ttc" id="aprint__list_8h_html"><div class="ttname"><a href="print__list_8h.html">print_list.h</a></div></div>
<div class="ttc" id="aprint_8h_html_ad5337a574ea6c177f4ffb967393a3eb8"><div class="ttname"><a href="print_8h.html#ad5337a574ea6c177f4ffb967393a3eb8">cpp20print::printing::detail::get_options</a></div><div class="ttdeci">PrintOptions get_options(const T &amp;)</div><div class="ttdoc">Overloaded function; if T&amp; is not PrintOptions&amp; return default options.</div><div class="ttdef"><b>Definition:</b> print.h:99</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_ad6abfeabd9d43b6bc40c801ee9f8c447"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#ad6abfeabd9d43b6bc40c801ee9f8c447">cpp20print::printing::PrintOptions::seperator</a></div><div class="ttdeci">std::string seperator</div><div class="ttdoc">Defines how the output of each argument of the print function is seperated from the next one.</div><div class="ttdef"><b>Definition:</b> print_options.h:45</div></div>
<div class="ttc" id="aprint_8h_html_aeee5a1be79dd7c9cb87c7f6aa842a89a"><div class="ttname"><a href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">cpp20print::printing::print</a></div><div class="ttdeci">void print(const Args &amp;...args)</div><div class="ttdoc">Prints any object.</div><div class="ttdef"><b>Definition:</b> print.h:117</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_adfa26c950f1582c78c5959e92105b3b0"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#adfa26c950f1582c78c5959e92105b3b0">cpp20print::printing::PrintOptions::file</a></div><div class="ttdeci">std::reference_wrapper&lt; std::ostream &gt; file</div><div class="ttdoc">Defines the stream to which the output of print is directed (default=&quot;std::cout&quot;)</div><div class="ttdef"><b>Definition:</b> print_options.h:53</div></div>
<div class="ttc" id="aprint__options_8h_html"><div class="ttname"><a href="print__options_8h.html">print_options.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
